scala.tools.nsc.backend.jvm.opt

# InlineInfoAttribute

###
Related Docs: object InlineInfoAttribute | package opt

#### case class InlineInfoAttribute(inlineInfo: InlineInfo) extends Attribute with Product with Serializable

This attribute stores the InlineInfo for a ClassBType as an independent classfile attribute. The compiler does so for every class being compiled.

The reason is that a precise InlineInfo can only be obtained if the symbol for a class is available. For example, we need to know if a method is final in Scala's terms, or if it has the @inline annotation. Looking up a class symbol for a given class filename is brittle (name-mangling).

The attribute is also helpful for inlining mixin methods. The mixin phase only adds mixin method symbols to classes that are being compiled. For all other class symbols, there are no mixin members. However, the inliner requires an InlineInfo for inlining mixin members. That problem is solved by reading the InlineInfo from this attribute.

In principle we could encode the InlineInfo into a Java annotation (instead of a classfile attribute). However, an attribute allows us to save many bits. In particular, note that the strings in an InlineInfo are serialized as references to constants in the constant pool, and those strings (traitImplClassSelfType, method names, method signatures) would exist in there anyway. So the ScalaInlineAttribute remains relatively compact.

Source
  InlineInfoAttribute.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, Attribute, AnyRef, Any
Known Subclasses
InlineInfoAttributePrototype
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. InlineInfoAttribute
2. Serializable
3. Serializable
4. Product
5. Equals
6. Attribute
7. AnyRef
8. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new InlineInfoAttribute(inlineInfo: InlineInfo)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from InlineInfoAttribute to any2stringadd[InlineInfoAttribute] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (InlineInfoAttribute, B)

   Implicit information
     This member is added by an implicit conversion from InlineInfoAttribute to ArrowAssoc[InlineInfoAttribute] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @IntrinsicCandidate() @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### def ensuring(cond: (InlineInfoAttribute) ⇒ Boolean, msg: ⇒ Any): InlineInfoAttribute

   Implicit information
     This member is added by an implicit conversion from InlineInfoAttribute to Ensuring[InlineInfoAttribute] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (InlineInfoAttribute) ⇒ Boolean): InlineInfoAttribute

   Implicit information
     This member is added by an implicit conversion from InlineInfoAttribute to Ensuring[InlineInfoAttribute] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): InlineInfoAttribute

    Implicit information
      This member is added by an implicit conversion from InlineInfoAttribute to Ensuring[InlineInfoAttribute] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): InlineInfoAttribute

    Implicit information
      This member is added by an implicit conversion from InlineInfoAttribute to Ensuring[InlineInfoAttribute] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from InlineInfoAttribute to StringFormat[InlineInfoAttribute] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

14. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

15. #### def getLabels(): Array[Label]

    Attributes
      protected[scala.tools.asm]
    Definition Classes
      Attribute

16. #### val inlineInfo: InlineInfo

17. #### def isCodeAttribute(): Boolean

    Definition Classes
      Attribute

18. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

19. #### def isUnknown(): Boolean

    Not sure what this method is good for, it is not invoked anywhere in the ASM framework.

    Not sure what this method is good for, it is not invoked anywhere in the ASM framework. However, the example in the ASM manual also overrides it to `false` for custom attributes, so it might be a good idea.

    Definition Classes
      InlineInfoAttribute → Attribute

20. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

21. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

22. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

23. #### def read(cr: ClassReader, off: Int, len: Int, buf: Array[Char], codeOff: Int, labels: Array[Label]): InlineInfoAttribute

    De-serialize the attribute into an InlineInfo.

    De-serialize the attribute into an InlineInfo. The attribute starts at cr.b(off), but we don't need to access that array directly, we can use the `read` methods provided by the ClassReader.

    `buf` is a pre-allocated character array that is guaranteed to be long enough to hold any string of the constant pool. So we can use it to invoke `cr.readUTF8`.

    Definition Classes
      InlineInfoAttribute → Attribute

24. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

25. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

28. #### def write(cw: ClassWriter, code: Array[Byte], len: Int, maxStack: Int, maxLocals: Int): ByteVector

    Serialize the `inlineInfo` into a byte array.

    Serialize the `inlineInfo` into a byte array. Strings are added to the constant pool and serialized as references.

    Definition Classes
      InlineInfoAttribute → Attribute

29. #### def →[B](y: B): (InlineInfoAttribute, B)

    Implicit information
      This member is added by an implicit conversion from InlineInfoAttribute to ArrowAssoc[InlineInfoAttribute] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from Attribute

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from InlineInfoAttribute to any2stringadd[InlineInfoAttribute]

### Inherited by implicit conversion StringFormat from InlineInfoAttribute to StringFormat[InlineInfoAttribute]

### Inherited by implicit conversion Ensuring from InlineInfoAttribute to Ensuring[InlineInfoAttribute]

### Inherited by implicit conversion ArrowAssoc from InlineInfoAttribute to ArrowAssoc[InlineInfoAttribute]

### Ungrouped